
;16-bit DOS program
;display keyboard character codes (hexidecimal version)
;by DednDave

;-------------------------------------------------------------------------

        .MODEL  SMALL
        .STACK  512

;-------------------------------------------------------------------------

        .DATA

ExitMsg db 'Press Esc Key to Exit',0Dh,0Ah,24h
HexStrg db '1234',0Dh,0Ah,24h

;-------------------------------------------------------------------------

        .CODE

_main   PROC

;set the DS register to the data segment

        mov     ax,@DATA
        mov     ds,ax

;display the exit message

        mov     dx,offset ExitMsg
        mov     ah,9
        int     21h

;poll the keyboard

DosKb0: call    KbInp
        jnz     DosKb1

;if no keyboard character, 55 ms delay, then try again

        call    Delay
        jmp     DosKb0

;we have a character
;display the character and character code
;test for Esc Key - if it is, exit
;if not, go back for another key

DosKb1: push    ax
        int     29h             ;display the character
        mov     al,20h
        int     29h             ;display a space character
        pop     ax
        call    B2Hex           ;display the value in AX
        cmp     al,1Bh          ;was it esc key ?
        jnz     DosKb0          ;no - do another key

;terminate

DosKb2: mov     ax,4C00h
        int     21h

_main   ENDP

;-------------------------------------------------------------------------

KbInp   PROC

;poll the keyboard for a character
;if it is an extended key, read the extended character

;returns with ZF set if there is no key
;returns with ZF clear if there is a key

; regular key: ah = 0, al = key
;extended key: al = 0, ah = extended key

;note: the function and arrow keys are extended keys

        mov     dl,0FFh
        mov     ah,6
        int     21h
        mov     ah,0
        jz      KBinp0

        or      al,al
        jnz     KbInp0

        mov     dl,0FFh
        mov     ah,6
        int     21h
        mov     ah,al
        mov     al,0
        xor     dx,dx
        dec     dx            ;clear the ZF

KbInp0: ret

KbInp   ENDP

;-------------------------------------------------------------------------

Delay   PROC

;delay for about 55 ms - that is fast enough for 180 wpm typing

;get the initial timer count

        mov     ah,0
        int     1Ah
        xchg    ax,dx
        add     ax,3

;once ~55 ms has elapsed, exit the routine

Delay0: push    ax
        mov     ah,0
        int     1Ah
        pop     ax
        cmp     ax,dx
        ja      Delay0

        ret

Delay   ENDP

;-------------------------------------------------------------------------

B2Hex   PROC

;display the binary value from AX in hexidecimal
;the AX register is preserved

        push    ax

        mov     di,offset HexStrg+4
        mov     bx,4090h
        mov     dx,ax
        mov     cx,4

B2Hex0: and     ax,0Fh
        add     al,bl                ;hex digit to char
        daa
        adc     al,bh
        daa
        dec     di
        mov     [di],al
        shr     dx,1
        shr     dx,1
        shr     dx,1
        shr     dx,1
        mov     ax,dx
        loop    B2Hex0

        mov     dx,di
        mov     ah,9
        int     21h                  ;display the string

        pop     ax
        ret

B2Hex   ENDP

;-------------------------------------------------------------------------

        END     _main

